<template>
    <tr>
        <td>{{ order.id }}</td>
        <td>{{ order.created_at | moment }}</td>
        <td>
            <div v-for="variation in products" :key="variation.id">
              <div class="flex flex-col items-center"></div>
                <div><nuxt-link
                    :to="localePath({
                        name: 'products-slug',
                        params: {
                            slug: variation.product.slug
                        }
                    })"
                >
                    {{ variation.product.name }} ({{ variation.name }})
                </nuxt-link>
                </div>
                <div class="text-sm text-gray-800">SKU: <span class="font-semibold text-gray-700">{{ variation.sku }}</span></div>
            </div>
            <template v-if="moreProducts > 0">
                e mais {{ moreProducts }} produtos
            </template>
        </td>
        <td>{{ order.total }}</td>
        <td>
            <component :is="order.status" :order="order"/>
        </td>
        <td>
            <div v-if="order.externalResourceUrl">
                <a :href="order.externalResourceUrl" target="_blank" rel="noopener">
                    <b-icon
                        icon="barcode"
                        size="is-large"
                        type="is-info">
                    </b-icon>
                </a>

            </div>
        </td>
    </tr>
</template>
<script>
import OrderStatusPaymentFailed from '@/components/orders/statuses/OrderStatus-payment_failed';
import OrderStatusRejected from '@/components/orders/statuses/OrderStatus-rejected';
import OrderStatusPending from '@/components/orders/statuses/OrderStatus-pending';
import OrderStatusComplete from '@/components/orders/statuses/OrderStatus-complete';
import OrderStatusProcessing from '@/components/orders/statuses/OrderStatus-processing';
import moment from 'moment';

export default {
    components: {
        'payment_failed': OrderStatusPaymentFailed,
        'rejected': OrderStatusRejected,
        'pending': OrderStatusPending,
        'complete': OrderStatusComplete,
        'processing': OrderStatusProcessing
    },
    filters: {
        moment(val){
            return moment(val).format("DD/MM/YYYY HH:mm")
        }
    },

    props: {
        order: {
            required: true,
            type: Object

        },
        maxProducts: {
            type: Number,
            default: 2,
        }
    },

    computed: {
        products() {
            return this.order.products.slice(0, this.maxProducts)
        },

        moreProducts() {
            return this.order.products.length - this.maxProducts
        },

        statusClasses() {
            return {
                'is-success': this.order.status === 'complete',
                'is-info': ['processing', 'pending'].includes(this.order.status),
                'is-danger': this.order.status === 'payment_failed',
            };
        }
    }
}
</script>

<style>
    a {
        text-decoration: none !important;
    }
</style>
